Bug 1028164 - Review Request: globus-xio-gridftp-driver - Globus Toolkit - Globus XIO GridFTP Driver
Review Request: globus-xio-gridftp-driver - Globus Toolkit - Globus XIO GridF...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adrien Devresse
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-07 14:32 EST by Mattias Ellert
Modified: 2013-12-27 17:15 EST (History)
2 users (show)

See Also:
Fixed In Version: globus-xio-gridftp-driver-1.2-2.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-12-22 00:44:04 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
adev88: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Mattias Ellert 2013-11-07 14:32:47 EST
Spec URL: http://www.grid.tsl.uu.se/review/globus-xio-gridftp-driver.spec
SRPM URL: http://www.grid.tsl.uu.se/review/globus-xio-gridftp-driver-1.2-1.fc19.src.rpm

Description:
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The globus-xio-gridftp-driver package contains:
Globus XIO GridFTP Driver

This is a new package introduced in Globus Toolkit 5.2.5

The .la file is intentional see:
http://fedoraproject.org/wiki/Packaging:Globus#Plugins

Fedora Account System Username: ellert
Comment 1 Adrien Devresse 2013-12-11 08:55:27 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- globus-core > 8 is already needed by globus-ftp-client-devel, no need of a direct dependency
- globus-xio-devel%{?_isa} >= 3  of -devel package already included by  globus-xio-gsi-driver-devel%{?_isa} >= 2
- depending on a doc package "globus-xio-doc >= 3" for compilation sounds wierd to me, Is it strictly needed  ?
- Koji build on EPEL 5 ppc failed

Comments:
========
- please change the msg "#		### INSERT PATCH DESCRIPTION HERE ###:" to a patch description msg
- No Unit test %check section

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[-]: Package contains no static executables.
	-> Not respected, but exemption from Globus packaging rules.

[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
	-> ASL 2.0 everywhere

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 


[x]: License file installed when any subpackage combination is installed.
	-> installed in core package
[x]: %build honors applicable compiler flags or justifies otherwise.
	-> use %configure
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required

	-> needed for EPEL 5

[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
	-> Used for build requires, but not a problem
[w]: Package consistently uses macros (instead of hard-coded directory names).
	-> Not for everything, but due to the file lsit usage

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Buildroot is not present
     Note: Buildroot: present but not needed

	-> Needed for EPEL 5

[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required

	-> Needed for EPEL 5

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in globus-xio-
     gridftp-driver-doc
		-> No Arch package not needed

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise justified.
	-> Minor patch for xml generator

[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: Package should compile and build into binary rpms on all supported
     architectures.
	-> ppc problem
	
[!]: %check is present and all tests pass.
	-> no Tests
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: globus-xio-gridftp-driver-1.2-1.el6.x86_64.rpm
          globus-xio-gridftp-driver-devel-1.2-1.el6.x86_64.rpm
          globus-xio-gridftp-driver-doc-1.2-1.el6.noarch.rpm
          globus-xio-gridftp-driver-1.2-1.el6.src.rpm
globus-xio-gridftp-driver-devel.x86_64: W: no-documentation
globus-xio-gridftp-driver.src:162: E: files-attr-not-set
globus-xio-gridftp-driver.src:163: E: files-attr-not-set
globus-xio-gridftp-driver.src:164: E: files-attr-not-set
globus-xio-gridftp-driver.src:169: E: files-attr-not-set
globus-xio-gridftp-driver.src: W: malformed-rhel-conditional globus-xio-gridftp-driver.spec:35
globus-xio-gridftp-driver.src: W: malformed-fedora-conditional globus-xio-gridftp-driver.spec:40
globus-xio-gridftp-driver.src: W: malformed-rhel-conditional globus-xio-gridftp-driver.spec:40
globus-xio-gridftp-driver.src: W: malformed-fedora-conditional globus-xio-gridftp-driver.spec:65
globus-xio-gridftp-driver.src: W: malformed-rhel-conditional globus-xio-gridftp-driver.spec:65
4 packages and 0 specfiles checked; 4 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint globus-xio-gridftp-driver-devel globus-xio-gridftp-driver globus-xio-gridftp-driver-doc
globus-xio-gridftp-driver-devel.x86_64: I: enchant-dictionary-not-found en_US
globus-xio-gridftp-driver-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
globus-xio-gridftp-driver-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    globus-ftp-client-devel(x86-64)
    globus-xio-devel(x86-64)
    globus-xio-gridftp-driver(x86-64)
    globus-xio-gsi-driver-devel(x86-64)
    libglobus_xio_gridftp_driver.so.1()(64bit)
    pkgconfig(globus-ftp-client)
    pkgconfig(globus-xio)
    pkgconfig(globus-xio-gsi-driver)

globus-xio-gridftp-driver (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    globus-xio-gsi-driver(x86-64)
    libc.so.6()(64bit)
    libglobus_common.so.0()(64bit)
    libglobus_common.so.0(GLOBUS_COMMON_14)(64bit)
    libglobus_ftp_client.so.2()(64bit)
    libglobus_xio.so.0()(64bit)
    libglobus_xio_gridftp_driver.so.1()(64bit)
    rtld(GNU_HASH)

globus-xio-gridftp-driver-doc (rpmlib, GLIBC filtered):
    globus-xio-gridftp-driver



Provides
--------
globus-xio-gridftp-driver-devel:
    globus-xio-gridftp-driver-devel
    globus-xio-gridftp-driver-devel(x86-64)
    pkgconfig(globus-xio-gridftp-driver)

globus-xio-gridftp-driver:
    globus-xio-gridftp-driver
    globus-xio-gridftp-driver(x86-64)
    libglobus_xio_gridftp_driver.so.1()(64bit)
    libtool(/usr/lib64/libglobus_xio_gridftp_driver.la)

globus-xio-gridftp-driver-doc:
    globus-xio-gridftp-driver-doc



Source checksums
----------------
http://www.globus.org/ftppub/gt5/5.2/5.2.5/packages/src/globus_xio_gridftp_driver-1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 577f40e6f2d1e34a443b8f393e687e797bc8e554dddeac37e3785e04eaa36986
  CHECKSUM(SHA256) upstream package : 577f40e6f2d1e34a443b8f393e687e797bc8e554dddeac37e3785e04eaa36986


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1028164
Buildroot used: epel-6-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG

BUILDS:
======


Rawhide http://koji.fedoraproject.org/koji/taskinfo?taskID=6279836

	-> Success

EPEL 5 : http://koji.fedoraproject.org/koji/taskinfo?taskID=6279882
	-> Failure
Comment 2 Mattias Ellert 2013-12-11 15:32:56 EST
(In reply to Adrien Devresse from comment #1)
> 
> Issues:
> =======
> - globus-core > 8 is already needed by globus-ftp-client-devel, no need of a
> direct dependency
> - globus-xio-devel%{?_isa} >= 3  of -devel package already included by 
> globus-xio-gsi-driver-devel%{?_isa} >= 2

These build dependencies are direct build dependencies. Using indirect dependencies of other build dependencies to fulfil direct build dependences is in most cases not a good idea, since indirect dependencies can change when the version of the dependencies change. While it is true that the current version of globus-xio-gsi-driver-devel has a dependency on globus-xio-devel >= 3 this does not imply that all previous versions of globus-xio-gsi-driver-devel had such a requirement, or that all future versions will have it.

> - depending on a doc package "globus-xio-doc >= 3" for compilation sounds
> wierd to me, Is it strictly needed  ?

Yes. Without it configure fails:

checking documentation dependencies... failed
configure: error: Documentation dependencies could not be satisfied.

> - Koji build on EPEL 5 ppc failed

You tried to build a SRPM generated on Fedora 19 on EPEL 5. This fails since newer versions of rpm uses more modern digest algorithms that are not supported by the older rpm version on EPEL 5. If this should work you need to force the use of MD5 instead of the default.

New version with proper reference for the patch:

http://www.grid.tsl.uu.se/review/globus-xio-gridftp-driver-1.2-2.fc19.src.rpm
http://www.grid.tsl.uu.se/review/globus-xio-gridftp-driver.spec

(This srpm was generated using rpmbuild-md5 so sould build on EPEL 5)
Comment 3 Adrien Devresse 2013-12-12 08:12:51 EST
> These build dependencies are direct build dependencies. Using indirect dependencies of other build dependencies to fulfil direct build dependences is in most cases not a good idea, since indirect dependencies can change when the version of the dependencies change. While it is true that the current version of globus-xio-gsi-driver-devel has a dependency on globus-xio-devel >= 3 this does not imply that all previous versions of globus-xio-gsi-driver-devel had such a requirement, or that all future versions will have it.

Question of point of view :) 
For devel packages, removing a dependency to an other -devel package means often an API/ABI break  which should not occurs anyway.
However, I know that the globus dependency tree is not trivial
I wanted to signal it, but it's clearly not a blocking issue for me.

> Yes. Without it configure fails:
>
> checking documentation dependencies... failed
> configure: error: Documentation dependencies could not be satisfied.

Fine for me.


> You tried to build a SRPM generated on Fedora 19 on EPEL 5. This fails since newer versions of rpm uses more modern digest algorithms that are not supported by the older rpm version on EPEL 5. If this should work you need to force the use of MD5 instead of the default.

My apologizes for this, I did not think to this usual md5 problem.

EL5 compiles now without problems :

EL5: http://koji.fedoraproject.org/koji/taskinfo?taskID=6283592


Nothing critical anymore for me, package well done & accepted.

Adrien
Comment 4 Mattias Ellert 2013-12-12 10:05:02 EST
Many thanks for the review.

New Package SCM Request
=======================
Package Name: globus-xio-gridftp-driver
Short Description: Globus Toolkit - Globus XIO GridFTP Driver
Owners: ellert
Branches: f18 f19 f20 el5 el6
InitialCC:
Comment 5 Gwyn Ciesla 2013-12-12 10:20:49 EST
Git done (by process-git-requests).
Comment 6 Fedora Update System 2013-12-12 12:22:48 EST
globus-xio-gridftp-driver-1.2-2.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/globus-xio-gridftp-driver-1.2-2.el5
Comment 7 Fedora Update System 2013-12-12 12:22:58 EST
globus-xio-gridftp-driver-1.2-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/globus-xio-gridftp-driver-1.2-2.fc18
Comment 8 Fedora Update System 2013-12-12 12:23:11 EST
globus-xio-gridftp-driver-1.2-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/globus-xio-gridftp-driver-1.2-2.fc19
Comment 9 Fedora Update System 2013-12-12 12:23:20 EST
globus-xio-gridftp-driver-1.2-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/globus-xio-gridftp-driver-1.2-2.fc20
Comment 10 Fedora Update System 2013-12-12 12:23:30 EST
globus-xio-gridftp-driver-1.2-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/globus-xio-gridftp-driver-1.2-2.el6
Comment 11 Fedora Update System 2013-12-12 20:45:40 EST
globus-xio-gridftp-driver-1.2-2.el6 has been pushed to the Fedora EPEL 6 testing repository.
Comment 12 Fedora Update System 2013-12-22 00:44:04 EST
globus-xio-gridftp-driver-1.2-2.fc20 has been pushed to the Fedora 20 stable repository.
Comment 13 Fedora Update System 2013-12-22 00:44:26 EST
globus-xio-gridftp-driver-1.2-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 14 Fedora Update System 2013-12-22 00:45:24 EST
globus-xio-gridftp-driver-1.2-2.fc18 has been pushed to the Fedora 18 stable repository.
Comment 15 Fedora Update System 2013-12-27 17:15:13 EST
globus-xio-gridftp-driver-1.2-2.el5 has been pushed to the Fedora EPEL 5 stable repository.
Comment 16 Fedora Update System 2013-12-27 17:15:23 EST
globus-xio-gridftp-driver-1.2-2.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.